import  java.awt.*;
import java.applet.Applet;
import java.awt.image.*;

public class ProyectI extends Applet{

int Ancho=320,Alto=240;
Image pos,neg;
Scrollbar Scrb=new Scrollbar(Scrollbar.HORIZONTAL,1,1,-5,5);
CheckboxGroup g = new CheckboxGroup();
miCanvas canvas1; 
Checkbox radio1=new Checkbox("Move",g,false);
Checkbox radio2=new Checkbox("Erase",g,false);
Checkbox radio3=new Checkbox("Add",g,true);
TextField Carga=new TextField("1",3);
intTextField R1=new intTextField(255,4);
intTextField R2=new intTextField(0,4);   
intTextField R3=new intTextField(0,4);   
intTextField G1=new intTextField(255,4);   
intTextField G2=new intTextField(100,4);   
intTextField G3=new intTextField(0,4);   
intTextField B1=new intTextField(255,4);   
intTextField B2=new intTextField(150,4);   
intTextField B3=new intTextField(0,4);   

public void init() {
	pos=getImage(getDocumentBase(),"pos.gif");
	neg=getImage(getDocumentBase(),"neg.gif");
	MediaTracker tracker=new MediaTracker(this);
	tracker.addImage(pos,0);
	tracker.addImage(neg,0);
	try  {tracker.waitForID(0);}
	catch (InterruptedException e) {;}
	canvas1=new miCanvas(3,1,neg,pos,300,200);
	GridBagLayout gbl = new GridBagLayout();
	GridBagConstraints gbc=new GridBagConstraints();
	setLayout(gbl);
	Carga.setEditable( false );
	gbc.fill=GridBagConstraints.BOTH;
	gbc.weightx=1.0;
	gbc.weighty=0;
	setFont(new Font("Helvetica",Font.PLAIN,8));
	add(canvas1,gbl,gbc,0,0,10,1);
	add(radio1,gbl,gbc,0,1,2,1);
	add(radio2,gbl,gbc,0,2,2,1);
	add(radio3,gbl,gbc,0,3,2,1);
	add(Carga,gbl,gbc,1,4,1,1);
	add(new Label("Charge:",Label.RIGHT),gbl,gbc,0,4,1,1);	
	add(Scrb,gbl,gbc,2,4,2,1);
	add(new Button("Movil"),gbl,gbc,2,1,1,1);
	add(new Button("Force"),gbl,gbc,3,1,1,1);
	add(new Button("Intensity"),gbl,gbc,2,2,1,1);
	add(new Button("Potential"),gbl,gbc,3,2,1,1);
	add(new Button("Animate"),gbl,gbc,2,3,1,1);
	add(new Button("Clear"),gbl,gbc,3,3,1,1);
	add(new Button("Psychadelic"),gbl,gbc,4,1,6,1);
	add(new Label("R1",Label.RIGHT),gbl,gbc,4,2,1,1);
	add(new Label("R2",Label.RIGHT),gbl,gbc,4,3,1,1);
	add(new Label("R3",Label.RIGHT),gbl,gbc,4,4,1,1);
	add(R1,gbl,gbc,5,2,1,1);
	add(R2,gbl,gbc,5,3,1,1);
	add(R3,gbl,gbc,5,4,1,1);
	add(new Label("G1",Label.RIGHT),gbl,gbc,6,2,1,1);         
        add(new Label("G2",Label.RIGHT),gbl,gbc,6,3,1,1);         
        add(new Label("G3",Label.RIGHT),gbl,gbc,6,4,1,1);         
        add(G1,gbl,gbc,7,2,1,1);   
        add(G2,gbl,gbc,7,3,1,1);   
        add(G3,gbl,gbc,7,4,1,1);   
        add(new Label("B1",Label.RIGHT),gbl,gbc,8,2,1,1);         
        add(new Label("B2",Label.RIGHT),gbl,gbc,8,3,1,1);         
        add(new Label("B3",Label.RIGHT),gbl,gbc,8,4,1,1);         
        add(B1,gbl,gbc,9,2,1,1);   
        add(B2,gbl,gbc,9,3,1,1);   
        add(B3,gbl,gbc,9,4,1,1);   
	}

public boolean handleEvent( Event evt ) {
	if( evt.target instanceof Scrollbar )
        	{
                Carga.setText( 
                	Integer.toString( ((Scrollbar)evt.target).getValue()) );
            	canvas1.set_carga(((Scrollbar)evt.target).getValue());
            	return true;
            	}
        return super.handleEvent( evt );
        }

private void add(Component c, GridBagLayout gbl, GridBagConstraints gbc,
                 int x, int y,int w,int h) {
        gbc.gridx=x;
        gbc.gridy=y;
	gbc.gridwidth=w;
        gbc.gridheight=h;
        if (y<1) gbc.weighty=0;
        gbl.setConstraints(c,gbc);
        add(c);
        if (y<1) gbc.weighty=1.0;
        }

public boolean action( Event evt, Object obj) {
	if (obj.equals("Psychadelic"))
		if (R1.isValid() && R2.isValid() &&
			R3.isValid() && G1.isValid() &&
			G2.isValid() && G3.isValid() &&
			B1.isValid() && B2.isValid() &&
			B3.isValid()) {
			canvas1.setColores(R1.getValue(),R2.getValue(),
				R3.getValue(),G1.getValue(),G2.getValue(),
				G3.getValue(),B1.getValue(),B2.getValue(),
				B3.getValue());
			canvas1.setFunc(4);
			}	
	if (obj.equals("Potential")) canvas1.setFunc(2);
		else if (obj.equals("Clear")) canvas1.limpiar();
		else if (obj.equals("Animate")) canvas1.animar();
		else if (obj.equals("Intensity")) canvas1.setFunc(3);
		else if (obj.equals("Force")) canvas1.setFunc(1);
		else if (obj.equals("Movil")) canvas1.agrega_movil();
	if (evt.target.equals(radio1)) canvas1.set_mode(1);
		else if (evt.target.equals(radio2)) canvas1.set_mode(2);
		else if (evt.target.equals(radio3)) canvas1.set_mode(3);
	return true;
	}
}

//-----------------------------------------------

class intTextField extends TextField {

public intTextField(int def,int size) {
	super(""+def,size);
	}

public boolean isValid() {
	int value;
	try {
		value=Integer.valueOf(getText().trim()).intValue();
		if (value<0 || value>255)
			throw new NumberFormatException();
		}
	catch (NumberFormatException e) {
		requestFocus();
		return false;
		}
	return true;
	}

public int getValue() {
	return Integer.parseInt(getText().trim());
	}
}

//-------------------------------------------------

class miCanvas extends Canvas implements Runnable {

int accion,c;
CargaS mc;
Image neg,pos;
int radio,indice;
Image fondo,cycledimage;
int func,ANCHO,ALTO;
int r1,r2,r3,g1,g2,g3,b1,b2,b3;
boolean grafico=false,animando=false,animar=false;
boolean grafico2=false,movil=false,buffer=false,dragando=false;;
int xdrag,ydrag;
Thread runner;
Image Off_i;
Graphics Off_g;	
Recicla filtro;
	
miCanvas(int accion,int carga,Image pos,Image neg,int anc,int alt) {
	resize(anc,alt);
	Dimension d=this.size();
	ANCHO=d.width;
	ALTO=d.height;
	setFont(new Font("Symbol",Font.PLAIN,10));
	this.neg=neg;
	this.pos=pos;
	radio=(neg.getWidth(this)>>1);
	c=carga;
	this.accion=accion;
	mc=new CargaS(radio,ANCHO,ALTO);
	filtro=new Recicla(8,256);
	func=0;
	start();
	}

public void start() {
        if(runner == null) {
        	runner = new Thread(this);
        	runner.start();
        	}
	}

public void stop() {
        if(runner != null) {
	        runner.stop();
                runner = null;
        	}
	}

public void setColores(int r1,int r2,int r3,int g1,int g2,int g3,
			int b1,int b2,int b3) {
	this.r1=r1;this.g1=g1;this.b1=b1;
	this.r2=r2;this.g2=g2;this.b2=b2;
	this.r3=r3;this.g3=g3;this.b3=b3;
	}
	
public void paint( Graphics g ) {
       	if (animando&&!animar) g.drawImage(cycledimage,0,0,this);
       	else if (grafico||grafico2) g.drawImage(fondo,0,0,this);
       	else {
       		g.setColor(Color.white);                            
       		g.fillRect(0,0,ANCHO,ALTO);
       		} 
	for (int i=0;i<mc.cuantas();i++)
       		if (mc.cargas[i].c<0) 
       			g.drawImage(neg,(int)mc.cargas[i].x-radio,
       				(int)mc.cargas[i].y-radio,this);	
 		else
      			g.drawImage(pos,(int)mc.cargas[i].x-radio,
      				(int)mc.cargas[i].y-radio,this);
	}

void Sleep(int t) {
	try {runner.sleep(t);}
	catch (InterruptedException e) {;}
	}

public void Info(Graphics gr,String status, int porcentaje) {
	FontMetrics fm=gr.getFontMetrics();
	String str=(status+" "+porcentaje+"%");
	int x = fm.stringWidth(str);
	int y = fm.getDescent()+fm.getAscent();
	gr.setColor(Color.white);
	gr.fillRect(0,0,ANCHO,y+3);
	gr.setColor(Color.black);
	gr.fillRect(0,0,ANCHO*porcentaje/100,y+3);
	gr.setXORMode(Color.white);
	gr.drawString(str,(ANCHO-x)>>1,y+1);
	gr.setPaintMode();
	Sleep(5);             //sin estas 2 lineas no pinta en 
	repaint(0,0,1,1);     //mi sistema...
	}

public boolean mouseDown(Event evt,int x,int y) {
	switch(accion){
		case 1:	if (mc.cuantas()==0) return false;
		       	indice=mc.mas_cercana(x,y);
		       	xdrag=x;
		       	ydrag=y;
		       	dragando=true;
		       	break;
		case 2:	mc.borrar_carga(x,y);
		       	if (!mc.hay_movil()) movil=false;
		       	repaint();
		       	break;
		case 3:	mc.agregar_carga(x,y,c);
		       	repaint();
		       	break;
			}
	return(true);
	}

void agrega_movil() {
	mc.agrega_movil(c,Math.random()*(double)ANCHO,Math.random()
			*(double)ALTO);
	if (mc.hay_movil()) movil=true;
	}

void set_mode(int i) {
	if ((i<4)&&(i>0)) accion=i;
	}

void set_carga(int i) {
	c=i;
	}

public boolean mouseDrag(Event evt,int x,int y){
	if ((accion!=1)||(mc.cuantas()==0)) return false;
	xdrag=x;
	ydrag=y;
	return(true);
	}	 			

public boolean mouseUp(Event evt,int x,int y) {
	dragando=false;
	return(true);
	}

void fuerza() {
	Graphics Gr=getGraphics();
	Graphics aux_g;
	int e,c,x,y,dx,dy,i,tope=0;
	double d,E,Ex,Ey;
	Sleep(30); //si hay un repaint encolado, hacerlo aca, de otro
	           //modo borra la linea de info la primera vez
	animar=animando=grafico=grafico2=false;
	fondo=createImage(ANCHO,ALTO);
	aux_g=fondo.getGraphics();
	aux_g.setColor(new Color(100,100,255));
	aux_g.fillRect(0,0,ANCHO,ALTO);
	c=mc.cuantas();
	int X[]=new int[c];
	int Y[]=new int[c];
	int C[]=new int[c];
	mc.getXYCs(X,Y,C);
	for (int u=0;u<3;u++){
		if (u==0) aux_g.setColor(new Color(100,100,100));
		else if (u==1) aux_g.setColor(new Color(150,150,150));
		else aux_g.setColor(Color.lightGray);
		tope+=ANCHO;
		for(e=0;e<tope;e++){
			if (e%100==0) Info(Gr,"Fuerzas",(e+150*(u+1)*u)/18); 
			x=e%ANCHO;
			y=(int)(Math.random()*ALTO);
			Ex=Ey=0;
			for(i=0;i<c;i++){
				d=Math.sqrt((x-X[i])*(x-X[i])+(y-Y[i])*(y-Y[i]));
				Ex+=C[i]*(x-X[i])/(d*d*d);
				Ey+=C[i]*(y-Y[i])/(d*d*d);
				}
			E=Math.sqrt(Ex*Ex+Ey*Ey);
			dx=(int)(5.0*(Ex/E));
			dy=(int)(5.0*(Ey/E));
			aux_g.drawLine(x-dx,y-dy,x+dx,y+dy);
			}		
		}
	grafico2=true;
	repaint();
	aux_g.dispose();
	Gr.dispose();
	func=0;
	}

void dibuja_potencial() {
	Graphics Gr=getGraphics();
	boolean tmp=movil;
	movil=false;
	byte[] pix=new byte[ANCHO*ALTO];
	int i,x,y,cant,indice,max;
	double p;
	cant=mc.cuantas();
	int X[]=new int[cant];
        int Y[]=new int[cant];
        int C[]=new int[cant];
        mc.getXYCs(X,Y,C);
	indice=0;
	Sleep(30); 
	for (y=0;y<ALTO;y++) {
		if (y%20==0) Info(Gr,"Potencial",y*100/ALTO);		
		for (x=0;x<ANCHO ;x++) {
			p=0.0;
			for (i=0;i<cant;i++)
				p+=C[i]/Math.sqrt((x-X[i])*(x-X[i])
					+(y-Y[i])*(y-Y[i]));
			p=((p*5000.0)%256+256)%256;
			pix[indice++]=(byte)p;
			}
		}
	byte[] R = new byte[256];
	byte[] G = new byte[256];
	byte[] B = new byte[256];
	for(i = 0; i < 256; i++) 
	 	if (i%64>2) { 
			R[i] = (byte)255;
			G[i] = (byte)255;
			B[i] = (byte)255;
			}
	IndexColorModel paleta = new IndexColorModel(8,256,R,G,B);
	fondo=createImage(new MemoryImageSource(ANCHO, 
			ALTO,paleta,pix,0,ANCHO));
	cycledimage=createImage(new FilteredImageSource(
	                fondo.getSource(),filtro));
	grafico=true;
	grafico2=false;
	animando=false;
	movil=tmp;
	func=0;
	Gr.dispose();
	repaint();
	}	

void dibuja_intensidad() {
	Graphics Gr=getGraphics();
	boolean tmp=movil;
	movil=false;
	byte[] pix=new byte[ANCHO*ALTO];
	int x,y,cant,indice,i;
	double Ex=0.0,Ey=0.0,d,E;
	double E2=0.0;
	cant=mc.cuantas();
	int X[]=new int[cant];
       	int Y[]=new int[cant];
       	int C[]=new int[cant];
    	mc.getXYCs(X,Y,C);
	indice=0;
	Sleep(30); 
	for (y=0;y<ALTO;y++){
		if (y%20==0) Info(Gr,"Intensidad",y*100/ALTO);
	        for (x=0;x<ANCHO ;x++) {
	       		Ex=Ey=0.0;
	       		for (i=0;i<cant;i++) {
	       			d=Math.sqrt((x-X[i])*(x-X[i])+(y-Y[i])*(y-Y[i]));
	         		Ex+=C[i]*(x-X[i])/(d*d*d);
	         		Ey+=C[i]*(y-Y[i])/(d*d*d);
	         		}
	        	E=(100000.0*Math.sqrt(Ex*Ex+Ey*Ey));
			if (E>255) pix[indice++]=(byte)255;
			else if (E<1) pix[indice++]=(byte)0;
			else pix[indice++]=(byte)(E);
	        	}
		}
	byte[] R = new byte[256];
	byte[] G = new byte[256];
	byte[] B = new byte[256];
	for(i = 0; i < 256; i++) {
		R[i]=(byte)i;
		B[i]=(byte)(255-i);
		}
	IndexColorModel paleta = new IndexColorModel(8,256,R,G,B);
	fondo=createImage(new MemoryImageSource(ANCHO,
			 ALTO,paleta,pix,0,ANCHO));
	cycledimage=createImage(new FilteredImageSource(
                         fondo.getSource(),filtro));
	grafico=true;
	grafico2=false;
	movil=tmp;
	func=0;
	animando=false;
	Gr.dispose();
	repaint();
	}

void sicodelico(int r1,int r2,int r3,int g1,int g2,int g3,
		int b1,int b2,int b3) {
	byte[] R=new byte[256];
	byte[] G=new byte[256];
	byte[] B=new byte[256];
	int i;  
	for(i=0;i<85;i++)
		{
		R[i]=(byte)(r1*(85-i)/85 + r2*i/85);
		G[i]=(byte)(g1*(85-i)/85 + g2*i/85);
		B[i]=(byte)(b1*(85-i)/85 + b2*i/85);
		R[i+85]=(byte)(r2*(85-i)/85 + r3*i/85);
		G[i+85]=(byte)(g2*(85-i)/85 + g3*i/85);
		B[i+85]=(byte)(b2*(85-i)/85 + b3*i/85);
		}
	for(i=0;i<86;i++) 
		{
		R[i+170]=(byte)(r3*(86-i)/86 + r1*i/86);
		G[i+170]=(byte)(g3*(86-i)/86 + g1*i/86);
		B[i+170]=(byte)(b3*(86-i)/86 + b1*i/86);
		}
	IndexColorModel paleta=new IndexColorModel(8,256,R,G,B);
	if (grafico) 
		{
		CambiaPaleta cambia=new CambiaPaleta(R,G,B,256);
		fondo=createImage(new FilteredImageSource(fondo.getSource(),
								cambia));
		cycledimage=createImage(new FilteredImageSource(
		                	fondo.getSource(),filtro));
		}
	else 
		{
		Graphics Gr=getGraphics();
		int x,y,indice=0;
		double d=0.0;
		byte[] pix = new byte[ANCHO * ALTO];
		int c=mc.cuantas();
		int X[]=new int[c];
	        int Y[]=new int[c];
       		int C[]=new int[c];
        	mc.getXYCs(X,Y,C);
		Sleep(30); 
		for (y=0;y<ALTO;y++){
                	if (y%20==0) Info(Gr,"Sicodelico",y*100/ALTO);
                	for (x=0;x<ANCHO ;x++)
                		{
                		d=0.0;
                		for (i=0;i<c;i++)
	        		d+=C[i]*Math.log((x-X[i])*(x-X[i])
						+(y-Y[i])*(y-Y[i]));
                        	d=(((d*20.0)%256)+256)%256;
                        	pix[indice++]=(byte)d;
                        	}
                        }
                 fondo=createImage(new MemoryImageSource(ANCHO,
                 	ALTO,paleta,pix,0,ANCHO));
                 cycledimage=createImage(new FilteredImageSource(
                                          fondo.getSource(),filtro));
                 Gr.dispose();
                 }
        grafico2=false;
	grafico=true;
	func=0;
	repaint();
	}		

public void limpiar() {
	if (animar) { 
		animando=animar=false;
		}
	else 
	if (grafico||grafico2) {
		animando=false;
		grafico2=false;
		grafico=false;
		}
	else {
		movil=animar=animando=grafico2=grafico=false;
		mc.reset();
		}
	repaint();
	}

public void setFunc(int i) {
	func=i;
	}

public void run() { 
	runner.setPriority(Thread.MIN_PRIORITY);
	while(true) {
		switch (func) {
			case 0:	break;
			case 1:	fuerza();
				break;
			case 2: dibuja_potencial();
				break;
			case 3: dibuja_intensidad();
				break;
			case 4:	sicodelico(r1,r2,r3,g1,g2,g3,b1,b2,b3);
				break;
			}
		if ((grafico)&&(animar)){
			Graphics aux=this.getGraphics();
			filtro.cycleColors();
			cycledimage.flush();
			MediaTracker tracker = new MediaTracker(this);
			tracker.addImage(cycledimage,0);
			try {tracker.waitForID(0,1000);}
			catch (Exception e) {
				System.out.println("error en mediatracker");
				}
			try {
			  aux.drawImage(cycledimage,0,0,null); 
			  for (int i=0;i<mc.cuantas();i++)
                          if (mc.cargas[i].c<0)
                                  aux.drawImage(neg,(int)mc.cargas[i].x-radio,
                                          (int)mc.cargas[i].y-radio,this);
                          else
                                  aux.drawImage(pos,(int)mc.cargas[i].x-radio,
                                          (int)mc.cargas[i].y-radio,this);
			  }
			catch (NullPointerException e) {;}
			animando=true;
			}
		if (dragando) 
			if (mc.cargas[indice].movil) {
            		mc.setVx(indice,
                    	(double)((int)(xdrag-mc.cargas[indice].x)>>2));
                    mc.setVy(indice,
                        (double)((int)(ydrag-mc.cargas[indice].y)>>2));
                    }
                else {
                  	mc.dragar(xdrag,ydrag,indice);
                  	repaint();
                 	}
		if (movil) {
			mc.actualiza();
			if (!animar) repaint();
			}
		Sleep(20);
		}
	}

void animar() {
	if (grafico2||!grafico) return;
	animar=!animar;	
	}

public void update(Graphics g){
	if (!buffer) {
		Off_i=createImage(ANCHO,ALTO);
		Off_g=Off_i.getGraphics();
		Off_g.setColor(Color.white);
		buffer=true;
		}
	if (animar) return;
	if (animando) Off_g.drawImage(cycledimage,0,0,this);
	else if (grafico||grafico2) Off_g.drawImage(fondo,0,0,this);
	else Off_g.fillRect(0,0,ANCHO,ALTO);
	for (int i=0;i<mc.cuantas();i++)
  		if (mc.cargas[i].c<0)
              		Off_g.drawImage(neg,(int)mc.cargas[i].x-radio,
          	    		(int)mc.cargas[i].y-radio,this);
                else
                        Off_g.drawImage(pos,(int)mc.cargas[i].x-radio,
                                (int)mc.cargas[i].y-radio,this);
		g.drawImage(Off_i,0,0,this);
	}
}

//---------------------------------------------------------------

class CargaS{

int MAX_CARGAS;
int cant;
Carga cargas[];
int rad,ancho,alto;
	
CargaS(int radius,int ancho,int alto) {
	MAX_CARGAS=10;
        cant=0;
        cargas=new Carga[MAX_CARGAS+1];
	for (int i=0;i<MAX_CARGAS+1;i++)
		cargas[i] = new Carga(1,1,0);
	rad=radius;
	this.ancho=ancho;
	this.alto=alto;
	}

void reset() {
	cant=0;
	}
	
void actualiza() {
        double d,Ex=0.0,Ey=0.0;
        for (int i=0;i<cant;i++)
                if (cargas[i].movil){
                        Ex=Ey=0.0;
                        for (int j=0;j<cant;j++)
                                if (j!=i) {
                                        d=Math.sqrt(
                                          (cargas[j].x-cargas[i].x)
                                          *(cargas[j].x-cargas[i].x)+
                                          (cargas[j].y-cargas[i].y)
                                          *(cargas[j].y-cargas[i].y));
                                        if (d>5) {
                                          Ex+=cargas[i].c*cargas[j].c
                                              *(cargas[i].x-cargas[j].x)
                                              /(d*d*d);
                                          Ey+=cargas[i].c*cargas[j].c
                                              *(cargas[i].y-cargas[j].y)
                                              /(d*d*d);
                                                }
                                        else Ex=Ey=0.0;
					}                        
                        setVx(i,cargas[i].vx+6.0*Ex);
                        setVy(i,cargas[i].vy+6.0*Ey);
                        }
        for (int i=0;i<cant;i++)
                if (cargas[i].movil){
                        cargas[i].x+=cargas[i].vx;
                        cargas[i].y+=cargas[i].vy;
                        if ((cargas[i].x>ancho-rad)||(cargas[i].x<rad))
				setX(i,(double)(cargas[i].x+ancho)%ancho);
                        if ((cargas[i].y>alto-rad)|| (cargas[i].y<rad))
                              	setY(i,(double)(cargas[i].y+alto)%alto);
                }
        }

void agrega_movil(int c,double x,double y){
       	if (cant<MAX_CARGAS) cant++;
       	else return;
       	cargas[cant-1]=new Carga(c,x,y,true);
       	}

void agregar_carga(int x,int y,int c) {
        if (cant<MAX_CARGAS) cant++;
        else return;
        cargas[cant-1]=new Carga(x,y,c);
        }

void borrar_carga(int x,int y) {
        if (cant==0) return;
        int indice=mas_cercana(x,y);
        cargas[indice]=cargas[cant-1];
        cant--;
	}
        
int mas_cercana(int x,int y) {
        double min=100000.0,aux;
        int indice=0;
        for (int i=0;i<cant;i++){
	        aux=Math.sqrt((x-cargas[i].x)*(x-cargas[i].x)+
                             (y-cargas[i].y)*(y-cargas[i].y));
                if(aux<min){
         		min=aux;
                        indice=i;
                	}
                }
        return(indice);
        }

void getXYCs (int Xs[],int Ys[],int Cs[]) {
	for (int i=0;i<cant;i++) {
		Xs[i]=(int)cargas[i].x;
		Ys[i]=(int)cargas[i].y;
		Cs[i]=cargas[i].c;
		}
	}

boolean hay_movil() {
       	for (int i=0;i<cant;i++)
       		if (cargas[i].movil) return true;
       	return false;
	}
		        	
int cuantas(){
        return(cant);
        }

void dragar(int x,int y,int indice){
        if (cant==0) return;
        setX(indice,x);
        setY(indice,y);
        }

void setX(int i,double x) {
	if ((i>=0)&&(i<cant))
		cargas[i].x=x;
	}

void setY(int i,double y) {
        if ((i>=0)&&(i<cant))
                cargas[i].y=y;
        }


void setVx(int i,double v) {
	if ((i>=0)&&(i<cant))
		cargas[i].vx=v;
	}

void setVy(int i,double v) {
        if ((i>=0)&&(i<cant))
                cargas[i].vy=v;
        }
}

//-----------------------------------------------------------

final class Carga {

int c;
double x,y,vx,vy;
boolean movil;

Carga(double x,double y, int c) {
	this.x=x;
        this.y=y;
        this.c=c;
        movil=false;
        vx=0.0;
        vy=0.0;
        }

Carga(int carga,double x, double y,boolean m) {
	this.x=x;
	this.y=y;
	c=carga;
	movil=true;
	vx=Math.random()*4.0-2.0;
	vy=Math.random()*4.0-2.0;
	}
}
	
//--------------------------------------------------------

class Recicla extends RGBImageFilter {
int paso;
int colores;
int indice;
int medio;
byte[] aux;

public Recicla(int Paso, int Colors) {
	paso=Paso;
        colores=Colors;
        indice = 0;
        canFilterIndexColorModel = true;
	aux= new byte[colores];
	}

public void cycleColorComponent(byte component[]) {
        if (indice<medio) {
                System.arraycopy(component,0,aux,0,indice);
                System.arraycopy(component,indice,component,0,colores-indice);
                System.arraycopy(aux,0,component,colores-indice,indice);
                }
        else
                {
                System.arraycopy(component,indice,aux,0,colores-indice);
                System.arraycopy(component,0,component,colores-indice,indice);
                System.arraycopy(aux,0,component,0,colores-indice);
                }
	}

public void cycleColors() {
	indice = (indice + paso) % colores;
   	}

public int filterRGB(int x, int y, int rgb) {
      	return rgb;
   	}

public IndexColorModel filterIndexColorModel(IndexColorModel icm) {
      	int mapSize = icm.getMapSize();
      	byte reds[] = new byte[mapSize];
      	byte greens[] = new byte[mapSize];
      	byte blues[] = new byte[mapSize];
      	icm.getReds(reds);
      	icm.getGreens(greens);
      	icm.getBlues(blues);
      	cycleColorComponent(reds);
      	cycleColorComponent(greens);
      	cycleColorComponent(blues);
      	return new IndexColorModel(icm.getPixelSize(),
         		mapSize, reds, greens, blues);
   	}
}

//-----------------------------------------------------	

class CambiaPaleta extends RGBImageFilter {
byte R1[];
byte G1[];
byte B1[];
	
public CambiaPaleta(byte R[],byte G[],byte B[],int colores) {
	R1=new byte[colores];
	G1=new byte[colores];
	B1=new byte[colores];
	canFilterIndexColorModel = true;
	System.arraycopy(R,0,R1,0,colores);
	System.arraycopy(G,0,G1,0,colores);
	System.arraycopy(B,0,B1,0,colores);
	}

public int filterRGB(int x, int y, int rgb) {
	return rgb;
	}
	
public IndexColorModel filterIndexColorModel(IndexColorModel icm) {
	return new IndexColorModel(icm.getPixelSize(),icm.getMapSize(),
				R1,G1,B1);
	}
}

